; #= P&P.temp -rs
; ########################################
; Peace & Protection
; More config routines
; ########################################

alias _config2unload {
  if ($dialog(awayopt)) return
  if ($dialog(aboutpnp)) return
  if ($dialog(popupc)) return
  _unload config2
}

;
; Away options
;
dialog awayopt {
  title "Away System Options"
  icon script\pnp.ico
  option dbu
  size -1 -1 250 125

  edit "", 200, 1 1 1 1, hide autohs

  text "Configure:", 244, 5 7 27 10

  check "&Pager", 245, 32 4 27 12, push
  check "A&way logging", 246, 65 4 45 12, push
  check "&Auto-away", 247, 115 4 42 12, push
  check "&Messages", 248, 162 4 42 12, push
  check "&Other", 249, 210 4 27 12, push

  box "", 250, 5 18 240 85

  text "When away, defaults to:", 1, 14 45 70 8, right hide
  combo 2, 86 43 30 50, drop hide
  text "When auto-away, defaults to:", 3, 14 58 70 8, right hide
  combo 4, 86 56 30 50, drop hide
  text "When not away, defaults to:", 5, 14 71 70 8, right hide
  combo 6, 86 69 30 50, drop hide

  check "Use 'classic' pager window", 7, 135 58 100 8, hide

  check "Enable away logging on away", 8, 14 27 100 8, hide
  check "Enable away logging on auto-away", 9, 114 27 125 8, hide
  check "Clear awaylog on away", 10, 14 36 90 8, hide
  check "Close any open queries on away", 11, 114 36 110 8, hide
  check "Save permanent copy of away log to logs directory", 12, 14 45 190 8, hide

  box "What to log:", 17, 10 57 230 38, hide
  check "Log private messages and", 13, 14 68 72 8, hide
  combo 14, 87 66 85 50, drop hide
  check "Log channel events:", 15, 14 81 60 8, hide
  combo 16, 75 79 60 50, drop hide

  box "When you set away:", 30, 10 25 230 32, hide
  radio "Send an action", 18, 14 35 52 8, hide
  radio "Send a message", 19, 14 44 52 8, hide
  text "to all", 20, 67 40 20 8, hide
  check "channels", 21, 82 35 45 8, hide
  check "chats/queries", 22, 82 44 45 8, hide

  check "Repeat this every", 23, 140 39 52 8, hide
  text "minutes", 24, 209 40 20 8, hide
  edit "", 25, 192 38 15 11, hide

  box "Remind people that you're away if they:", 26, 10 62 230 33, hide
  check "Send you a private message", 27, 14 72 100 8, hide
  check "Use any of these words in a channel:", 28, 14 82 97 8, hide
  edit "", 29, 112 80 122 11, autohs hide

  check "Change nick on away to:", 37, 14 34 67 8, hide
  edit "", 31, 84 32 50 11, autohs hide
  text "(use &&me&& to represent old nick)", 32, 135 34 90 8, hide
  check "Disable sounds when away", 33, 14 46 80 8, hide
  check "Disable event beeps when away", 34, 14 58 90 8, hide
  check "Deop yourself in any channels when away", 35, 14 70 115 8, hide
  check "Enable dedicated query window when away", 36, 14 82  120 8, hide

  check "Automatically set away after", 42, 14 45 77 8, hide
  text "minutes idle", 38, 107 45 30 8, hide
  edit "", 39, 92 43 15 11, hide
  check "Warn you before setting auto-away", 40, 14 58 100 8, hide
  check "Perform auto-away quietly (don't inform channels / etc.)", 41, 14 71 150 8, hide

  button "OK", 241, 15 108 27 12, OK default
  button "Cancel", 242, 50 108 27 12, cancel
  button "Help", 243, 85 108 27 12, disable

  edit "", 100, 1 1 1 1, hide
}
on *:DIALOG:awayopt:init:*:{
  var %opt,%num = 2
  :loop1
  did -a $dname %num On
  did -a $dname %num Off
  did -a $dname %num Quiet
  %opt = $gettok(. away . autoaway . back,%num,32) $+ .pager
  %opt = $_cfgi(%opt)
  did -c $dname %num $iif(%opt == quiet,3,$iif(%opt,1,2))
  if (%num < 6) { inc %num 2 | goto loop1 }
  if ($_cfgi(pager.classic)) did -c $dname 7

  loadbuf -otawayopt1 $dname 14 script\dlgtext.dat
  loadbuf -otawayopt2 $dname 16 script\dlgtext.dat

  if ($_cfgi(away.log)) did -c $dname 8
  if ($_cfgi(autoaway.log)) did -c $dname 9
  if ($_cfgi(awaylog.clear)) did -c $dname 10
  if ($_cfgi(away.closeq)) did -c $dname 11
  if (%`awaylog.perm) did -c $dname 12
  if (%`awaylog.msg) did -c $dname 13
  else did -b $dname 14
  did -c $dname 14 $calc(1 + %`awaylog.close)
  if (%`awaylog.chan) did -c $dname 15
  else did -b $dname 16
  did -c $dname 16 $iif(%`awaylog.chan,%`awaylog.chan,1)

  did -c $dname $iif($_cfgi(away.act),18,19)
  if ($_cfgi(away.chan)) did -c $dname 21
  if ($_cfgi(away.msg)) did -c $dname 22
  if ($_cfgi(away.rep)) did -c $dname 23
  else did -b $dname 25
  did -a $dname 25 $_cfgi(away.delay)
  if (%`away.remind) did -c $dname 27
  if (%`awaywords) did -c $dname 28
  else did -b $dname 29
  did -a $dname 29 %`awaywords.words

  if ($_cfgi(away.chnick)) did -c $dname 37
  else did -b $dname 31
  did -a $dname 31 $_cfgi(away.nick)
  if ($_cfgi(away.sndoff)) did -c $dname 33
  if ($_cfgi(away.beepoff)) did -c $dname 34
  if ($_cfgi(away.deop)) did -c $dname 35
  if ($_cfgi(away.dq)) did -c $dname 36

  if (%`autoaway) did -c $dname 42
  else did -b $dname 39
  did -a $dname 39 $calc(%`autoaway.time / 60)
  if ($_cfgi(autoaway.ask)) did -c $dname 40
  if ($_cfgi(autoaway.quiet)) did -c $dname 41

  ; Select a section
  if ($pos(plamo,$left(%.section,1),1)) _acsec $ifmatch
  elseif ($_dlgi(away)) _acsec $ifmatch
  else _acsec 1

  unset %.section
}
on *:DIALOG:awayopt:sclick:13:_doflip 14
on *:DIALOG:awayopt:sclick:15:_doflip 16
on *:DIALOG:awayopt:sclick:23:_doflip 25
on *:DIALOG:awayopt:sclick:28:_doflip 29
on *:DIALOG:awayopt:sclick:37:_doflip 31
on *:DIALOG:awayopt:sclick:42:_doflip 39
alias -l _doflip did $iif($did($did).state,-e,-b) $dname $1
on *:DIALOG:awayopt:sclick:241:{
  ; save settings
  var %num = 2
  :loop1
  _cfgw $gettok(. away . autoaway . back,%num,32) $+ .pager $gettok(1 0 quiet,$did(%num).sel,32)
  if (%num < 6) { inc %num 2 | goto loop1 }
  _cfgw pager.classic $did(7).state

  _cfgw away.log $did(8).state
  _cfgw autoaway.log $did(9).state
  _cfgw awaylog.clear $did(10).state
  _cfgw away.closeq $did(11).state
  `set awaylog.perm $did(12).state
  `set awaylog.msg $did(13).state
  `set awaylog.close $calc($did(14).sel - 1)
  `set awaylog.chan $iif($did(15).state,$did(16).sel,0)

  _cfgw away.act $did(18).state
  _cfgw away.chan $did(21).state
  _cfgw away.msg $did(22).state
  _cfgw away.rep $did(23).state
  _cfgw away.delay $iif($did(25) isnum,$did(25),20)
  `set away.remind $did(27).state
  `set awaywords $did(28).state
  `set awaywords.words $_s2c($did(29))

  _cfgw away.chnick $did(37).state
  _cfgw away.sndoff $did(33).state
  _cfgw away.beepoff $did(34).state
  _cfgw away.deop $did(35).state
  _cfgw away.dq $did(36).state
  _cfgw away.nick $gettok($did(31),1,32)

  `set autoaway $did(42).state
  _cfgw autoaway.ask $did(40).state
  _cfgw autoaway.quiet $did(41).state
  `set autoaway.time $iif($did(39) isnum,$calc($did(39) * 60),1200)

  _dlgw away $did(100)

  .timer -o 1 0 _config2unload
}
on *:DIALOG:awayopt:sclick:242:.timer -o 1 0 _config2unload
on *:DIALOG:awayopt:sclick:*:if ($did isnum 245-249) _acsec $calc($did - 244)
alias -l _acsec {
  ; select radio btn
  if ($did(awayopt,100) isnum) did -u awayopt $calc(244 + $did(awayopt,100))
  did -o awayopt 100 1 $1
  did -c awayopt $calc(244 + $1)

  ; change the shown options
  var %range = $gettok(1-7 8-17 38-42 18-30 31-37,$1,32)
  if ($did(awayopt,200) == %range) return
  if ($did(awayopt,200)) _bulkdid -h awayopt $replace($did(awayopt,200),-,$chr(32))
  did -o awayopt 200 1 %range
  _bulkdid -v awayopt $replace(%range,-,$chr(32))
}
alias _awaycfg set %.section $1 | _dialog -am awayopt awayopt

;
; ABOUT dialog
;
dialog aboutpnp {
  title "About P&P"
  icon script\pnp.ico
  option dbu
  size -1 -1 125 140
  text "Peace && Protection", 2, 5 5 75 8
  text "by pai", 3, 5 13 75 8
  text "", 4, 5 21 75 8
  text "Dedicated to Awenyedd", 10, 5 29 75 8
  text "URL:", 5, 5 58 24 10, right
  text "E-Mail:", 6, 5 67 24 10, right
  link "", 7, 31 58 90 11
  link "", 8, 31 67 90 11
  button "Close", 1, 5 80 24 10, cancel default
  icon 9, 70 85 50 50
  button "Report a bug...", 11, 5 112 57 11
  button "Send feedback...", 12, 5 125 57 11
}
on *:DIALOG:aboutpnp:init:*:{
  unset %_cq
  did -a $dname 4 $:ver
  did -o $dname 7 1 $:www
  did -o $dname 8 1 $:email
  var %icon = $_dlgi(about)
  if (%icon !isnum) %icon = 1
  else %icon = $calc(%icon % 3 + 1)
  _dlgw about %icon
  did -g $dname 9 script\pai $+ %icon $+ .bmp
  .timer -mo 1 0 do3d
}
on *:DIALOG:aboutpnp:sclick:1:stop3d
on *:DIALOG:aboutpnp:sclick:7:http $:www | dialog -c aboutpnp
on *:DIALOG:aboutpnp:sclick:8:mailto $:email | dialog -c aboutpnp
on *:DIALOG:aboutpnp:sclick:11:.timer -o 1 0 bug | dialog -c aboutpnp
on *:DIALOG:aboutpnp:sclick:12:.timer -o 1 0 feedback | dialog -c aboutpnp
menu @PNP3D {
  sclick:fix3d
  dclick:fix3d | inc -u5 %.blah | if (%.blah > 1) %_cq = 1
  $fix3d:{ }
}
alias -l fix3d dialog -v aboutpnp
alias -l do3d window -pfdoha +dL @PNP3D $calc($dialog(aboutpnp).x + 145) $calc($dialog(aboutpnp).y + 25) 100 100 @PNP3D | %_cx = 0 | %_cy = 0 | %_cz = 0 | .timer3d -om 0 50 drawbox | dialog -v aboutpnp
alias -l draw3d { drawline -rn @PNP3D $rgb(frame) 1 $calc($1 + 50 + $calc($3 / 4)) $calc($2 + 50 - $calc($3 / 4)) $calc($4 + 50 + $calc($6 / 4)) $calc($5 + 50 - $calc($6 / 4)) }
alias -l drawbox {
  %_cx = $calc((%_cx + 4) % 256)
  %_cy = $calc((%_cy + 252.5) % 256)
  %_cz = $calc((%_cz + 2 + $sin($calc(0.02454 * %_cy))) % 256)
  dorots $cos($calc(0.02454 * %_cx)) $sin($calc(0.02454 * %_cx)) $cos($calc(0.02454 * %_cy)) $sin($calc(0.02454 * %_cy)) $cos($calc(0.02454 * %_cz)) $sin($calc(0.02454 * %_cz))
}
alias -l dodraws {
  drawrect -frn @PNP3D $rgb(face) 1 0 0 101 101
  draw3d $1-6 | draw3d $4-9 | draw3d $7-12 | draw3d $10-12 $1-3
  draw3d $13-18 | draw3d $16-21 | draw3d $19-24 | draw3d $22-24 $13-15
  draw3d $1-3 $13-15 | draw3d $4-6 $16-18 | draw3d $7-9 $19-21 | draw3d $10-12 $22-24
  drawdot @PNP3D | window @PNP3D $calc($dialog(aboutpnp).x + 145) $calc($dialog(aboutpnp).y + 25)
  if ($appactive) window -ro @PNP3D | else window -h @PNP3D
}
alias -l dorots dodraws %_cq $bitrot(-30,-30,30,$1,$2,$3,$4,$5,$6) $bitrot(30,-30,30,$1,$2,$3,$4,$5,$6) $bitrot(30,30,30,$1,$2,$3,$4,$5,$6) $bitrot(-30,30,30,$1,$2,$3,$4,$5,$6) $bitrot(-30,-30,-30,$1,$2,$3,$4,$5,$6) $bitrot(30,-30,-30,$1,$2,$3,$4,$5,$6) $bitrot(30,30,-30,$1,$2,$3,$4,$5,$6) $bitrot(-30,30,-30,$1,$2,$3,$4,$5,$6)
alias -l bitrot return $calc((($2 * $5 + $3 * $4) * $7 + $1 * $6) * $8 - ($2 * $4 - $3 * $5) * $9) $calc((($2 * $5 + $3 * $4) * $7 + $1 * $6) * $9 + ($2 * $4 - $3 * $5) * $8) $calc(($2 * $5 + $3 * $4) * $6 - $1 * $7)
alias -l stop3d .timer3d off | window -c @PNP3D | unset %_cx %_cy %_cz %_cq
alias _about $dialog(aboutpnp,aboutpnp,-2) | _config2unload

;
; popup config
;
dialog popupc {
  title "Configure Popups"
  icon script\pnp.ico
  option dbu
  size -1 -1 140 187

  list 10, 1 1 1 1, hide
  edit "", 11, 1 1 1 1, hide autohs

  text "Select a type of popups, and you select which items to show within those popups", 1, 5 5 130 15
  check "Menubar", 2, 5 22 40 12, push
  check "Query", 3, 50 22 40 12, push
  check "Channel", 4, 95 22 40 12, push
  check "Nicklist", 5, 5 40 40 12, push
  check "Status", 6, 50 40 40 12, push
  check "@Windows", 7, 95 40 40 12, push
  box "", 8, -10 55 150 200

  check "", 20, 5 65 85 10
  check "", 21, 5 75 85 10
  check "", 22, 5 85 85 10
  check "", 23, 5 95 85 10
  check "", 24, 5 105 85 10
  check "", 25, 5 115 85 10
  check "", 26, 5 125 85 10
  check "", 27, 5 135 85 10
  check "", 28, 5 145 85 10
  check "", 29, 5 155 85 10
  check "", 30, 5 165 85 10
  check "", 31, 5 175 85 10

  check "Hide op cmds", 50, 95 65 45 10
  text "if not opped", 51, 104 75 40 10

  button "OK", 100, 95 110 40 12, ok default
  button "Cancel", 101, 95 125 40 12, cancel
  button "Normal", 102, 95 140 40 12
  button "Condensed", 103, 95 155 40 12
  button "Help", 104, 95 170 40 12, disable
}
alias _popups _dialog -am popupc popupc
on *:DIALOG:popupc:init:*:{
  var %num = 1,%old
  :loop
  %old = %`popups. [ $+ [ %num ] ]
  %old = %old $+ $str(1,$calc(12 - $len(%old)))
  did -a popupc 10 %old
  if (%num < 6) { inc %num | goto loop }
  if (%`popups.hideop) did -c popupc 50
  if ($_dlgi(popupc) isnum 1-6) _pcsel $ifmatch | else _pcsel 1
}
on *:DIALOG:popupc:sclick:*:{
  if ($did isnum 2-7) _pcsel $calc($did - 1)
  elseif ($did isnum 20-31) {
    var %old = $did(10,$did(11))
    did -o popupc 10 $did(11) $left(%old,$calc($did - 20)) $+ $did($did).state $+ $right(%old,$calc(19 - $did))
  }
  elseif ($did == 100) {
    var %num = 1
    :loop
    `set popups. $+ %num $did(10,%num)
    if (%num < 6) { inc %num | goto loop }
    `set popups.hideop $did(50).state
    _dlgw popupc $did(11)
  }
  elseif ($did isnum 102-103) {
    did -o popupc 10 $did(11) $gettok($gettok(1010001110111 101011110100 011010101001 110011000110 011110111001 110100111111+1111001111111 010111111011 111111110111 001111111111 111111111111 111001111111,$calc(104 - $did),43),$did(11),32)
    _pcsel $did(11)
  }
  if ($did isnum 100-101) .timer -o 1 0 _config2unload
}
alias -l _pcsel {
  var %popups,%curr = $did(popupc,10,$1),%all
  did -o popupc 11 1 $1
  %all = 2,3,4,5,6,7
  goto $1
  :1 | %popups = Configure,Whois Tome / LastWhois,Lists,Away,Nickname,List channels,Channels,Favorites,Addons,Help! | goto do
  :2 | %popups = Whois,User info,Ping,CTCP,DCC,Ignore,Userlist,Notify,Window,Close,Help! | goto do
  :3 | %popups = Topic,Modes,Settings,Banlist,Bans,Ping,Scan,Favorites,Part,Window,Help! | goto do
  :4 | %popups = Quick kick,Quick ban,Kick,Bans,Op / Voice / Deop / Devoice,User info,CTCP,DCC,Query,Lists,Notices,Help!  | goto do
  :5 | %popups = List channels,Channels,Favorites,Nickname,Usermode,Quit,Server,Stats,Connect,Window,Help! | goto do
  :6 | %popups = Select all,Copy,Window,Close,Hide,Help! | goto do
  :do
  did $iif($1 isnum 3-4,-v,-h) popupc 50,51
  did -cf popupc $calc($1 + 1)
  did -u popupc $remtok(%all,$calc($1 + 1),1,44)
  var %num = 1
  :loop
  if ($gettok(%popups,%num,44)) {
    did -va popupc $calc(19 + %num) $ifmatch
    did $iif($mid(%curr,%num,1),-c,-u) popupc $calc(19 + %num)
  }
  else did -h popupc $calc(19 + %num)
  if (%num < 12) { inc %num | goto loop }
}
