; #= P&P.temp -rs
; ########################################
; Peace & Protection
; Register, bug report, etc.
; ########################################
 
dialog bugrep {
  title "Bug report and feedback"
  icon script\pnp.ico
option dbu
size -1 -1 250 192
 
text "To report a bug or problem with P&&P, use the 'Report a bug' section. To suggest features, or give other feedback, use the 'General feedback' section.", 1, 5 5 240 20
radio "Report a bug", 2, 5 25 50 12, push
radio "General feedback", 3, 60 25 50 12, push
box "", 4, 5 40 240 117
 
text "Please write a detailed description of the bug, including when it occurs and how it can be reproduced. Include any information that you think may help in reproducing the bug.", 5, 10 50 230 20
 
edit "", 6, 10 70 230 40, return vsbar multi
 
text "Please provide your e-mail in case we need to contact you. Due to limited time, replies will only be sent if more information is needed. We apologize that we cannot reply to everyone.", 7, 10 115 230 25
 
text "Your e-mail:", 8, 10 142 30 10, right
edit "", 9, 41 140 100 11, autohs
 
text "Press the Next button to continue.", 11, 10 162 150 10
button "Next >>", 12, 10 175 60 12, disable default
 
text "To aid us in finding and fixing the bug, you may wish to send us additional information about your computer and script configuration.", 13, 10 50 230 15, hide
 
check "Send basic system info", 14, 10 69 100 8, hide
check "Send P&&P and mIRC configuration", 15, 10 94 100 8, hide
check "Send recent debug.log", 16, 10 124 100 8, hide
 
text "This is information on mIRC version, operating system, and other very basic information, with no security risk.", 17, 110 70 120 20, hide
text "This includes most P&&P and mIRC settings, as well as the userlist. It includes the mIRC 'perform' section and any auto-events, so be warned, if you use these for passwords.", 18, 110 95 120 27, hide
text "This includes ALL data sent to and from mIRC since you last started mIRC. It will contain all non-DCC chat and any passwords, so only send this if absolutely needed.", 19, 110 125 120 30, hide
 
text "Press the Send button to send your bug report.", 20, 10 162 150 10, hide
button "Send!", 21, 10 175 60 12, hide disable OK
 
button "<< Back", 22, 95 175 60 12, hide
 
text "Please enter your feedback and comments.", 23, 10 50 230 20, hide
text "Press the Send button to send your feedback.", 24, 10 162 150 10, hide
 
button "Cancel", 100, 180 175 60 12, cancel
}
alias _bug set %.option $1 | _dialog -md bugrep bugrep
on *:DIALOG:bugrep:init:*:{
  if ($exists($mircdirdebug.log) == $false) did -b $dname 16,19
  if (%.option) {
    did -c $dname 3
    _clickbtn 3 $dname
  }
  else {
    did -c $dname 2,14
    did -f $dname 6
  }
  unset %.option
}
on *:DIALOG:bugrep:sclick:21:{
  %_br.file = $_temp(bug)
  window -c @.bug
  window -hln @.bug
  if ($did(2).state) {
    aline @.bug Subject: [AUTO] Bug report
  }
  else {
    aline @.bug Subject: [AUTO] Feedback
  }
  aline @.bug X-Mailer: Peace and Protection $:ver
  if ((@ isin $did(9)) && (. isin $did(9))) {
    aline @.bug From: $gettok($did(9),1,32)
    aline @.bug Reply-to: $gettok($did(9),1,32)
    titlebar @.bug smtp.pairc.com $gettok($did(9),1,32)
  }
  else titlebar @.bug smtp.pairc.com feedback@pairc.com
  aline @.bug $lf
  var %ln = 1,%num = $did(6).lines
  :loop
  if ($left($did(6,%ln).text,1) == $null) aline @.bug $lf
  else aline @.bug $did(6,%ln).text
  if (%ln < %num) { inc %ln | goto loop }
  aline @.bug $lf
  if ($did(2).state) {
    if ($did(14).state) {
      aline @.bug mIRC: $version $+ , $bits bit
      aline @.bug EXE: $mircexe
      aline @.bug INI: $mircini
      aline @.bug DIR: $mircdir
      if ($ip == $null) aline @.bug IP: (unknown)
      else aline @.bug IP: $ip
      aline @.bug Nickname: $me
      if ($server == $null) aline @.bug Server: (not connected)
      else aline @.bug Server: $server : $port
      aline @.bug OS: $os
      aline @.bug Timestamp: $ctime / $ticks
      aline @.bug Profile: %!user
      aline @.bug $lf
    }
    if ($did(15).state) {
      saveini
      aline @.bug *** $mircini
      loadbuf @.bug " $+ $mircini $+ "
      aline @.bug $lf
      aline @.bug *** $mircdirconfig\profiles.ini
      loadbuf @.bug " $+ $mircdirconfig\profiles.ini $+ "
      aline @.bug $lf
      aline @.bug *** $_cfg(config.ini)
      loadbuf @.bug " $+ $_cfg(config.ini) $+ "
      aline @.bug $lf
      aline @.bug *** $_cfg(cfgvar.dat)
      loadbuf @.bug " $+ $_cfg(cfgvar.dat) $+ "
      aline @.bug $lf
      aline @.bug *** $_cfg(users.mrc)
      loadbuf @.bug " $+ $_cfg(users.mrc) $+ "
      aline @.bug $lf
      aline @.bug *** $_cfg(display.dat)
      loadbuf @.bug " $+ $_cfg(display.dat) $+ "
      aline @.bug $lf
    }
    if ($did(16).state) {
      aline @.bug *** $mircdirdebug.log
      loadbuf 500 @.bug " $+ $mircdirdebug.log $+ "
      aline @.bug $lf
    }
    aline @.bug *** End of Data
  }
  _bugstart $did(2).state
}
alias _bugstart {
  _progress.1 Sending $iif($1,bug report...,feedback...)
  _progress.2 0 Connecting to $gettok($window(@.bug).title,1,32) $+ ...
  sockclose bugrep
  sockopen bugrep $gettok($window(@.bug).title,1,32) 25
}
on *:DIALOG:bugrep:sclick:100:_unload register
on *:DIALOG:bugrep:sclick:*:if ($did > 0) _clickbtn $did $dname
alias -l _clickbtn {
  if (($1 == 2) || ($1 == 22)) {
    did -v $2 5,6,7,8,9,11,12
    did -h $2 13,14,15,16,17,18,19,20,21,22,23,24
    did -t $2 12
    did -f $2 6
  }
  elseif ($1 == 3) {
    did -v $2 6,7,8,9,21,23,24
    did -h $2 5,11,12,13,14,15,16,17,18,19,20,22
    did -t $2 21
    did -f $2 6
  }
  elseif ($1 == 12) {
    did -v $2 13,14,15,16,17,18,19,20,21,22
    did -h $2 5,6,7,8,9,11,12,23,24
    did -t $2 21
    did -f $2 14
  }
}
on *:DIALOG:bugrep:edit:*:{
  if (($did($did).lines > 1) || ($did($did).text != $null)) {
    if ($did == 6) did -e $dname 12,21
  }
  else {
    if ($did == 6) did -b $dname 12,21
  }
}
on *:SOCKOPEN:bugrep:{
  if ($sockerr) _bugresend Error connecting to server: $sock($sockname).wsmsg
  _progress.2 0 Initiating transfer...
}
on *:SOCKWRITE:bugrep:{
  if ($sockerr) _bugresend Unexpected socket error: $sock($sockname).wsmsg
  if (($sock(bugrep).mark isnum) && ($sock(bugrep).mark > 0)) {
    var %ln = $ifmatch,%line = $line(@.bug,$ifmatch)
    if (%ln \\ 5) _progress.2 $int($calc(%ln * 100 / ($line(@.bug,0) + 2))) Sending data...
    if ($left(%line,1) == .) sockwrite -n bugrep . $+ %line
    else sockwrite -nt bugrep %line
    inc %ln
    if (%ln > $line(@.bug,0)) {
      sockwrite -n bugrep .
      sockmark bugrep 0
    }
    else sockmark bugrep %ln
  }
}
on *:SOCKREAD:bugrep:{
  var %data
  :readmore
  sockread %data
  if ($sockerr) _bugresend Unexpected socket error: $sock($sockname).wsmsg
  if ($sockbr) {
    tokenize 32 %data
    if ($1 == 220) sockwrite -n bugrep HELO $iif(. isin $host,$host,$iif($longip($ip),$ip,$gettok($window(@.bug).title,1,32)))
    elseif ($1 isnum 400-599) _bugresend Error from mail relay: $2-
    elseif ($1 == 354) {
      ; Send text
      sockmark bugrep 2
      sockwrite -n bugrep $line(@.bug,1)
    }
    elseif ($1 isnum 250-259) {
      ; From/to
      if ($sock(bugrep).mark == $null) {
        sockwrite -n bugrep MAIL FROM:< $+ $gettok($window(@.bug).title,2,32) $+ >
        sockmark bugrep a
      }
      elseif ($sock(bugrep).mark == a) {
        sockwrite -n bugrep RCPT TO:<feedback@pairc.com>
        sockmark bugrep b
      }
      elseif ($sock(bugrep).mark == b) {
        sockwrite -n bugrep DATA
        sockmark bugrep c
      }
      elseif ($sock(bugrep).mark == 0) {
        _progress.2 99 Disconnecting...
        sockwrite -n bugrep QUIT
      }
    }
    goto readmore
  }
}
on *:SOCKCLOSE:bugrep:{
  if ($sock(bugrep).mark == 0) {
    window -c @.bug
    _progress.2 100 Feedback sent, thank you!
    _unload register
  }
  else _bugresend Socket closed unexpectedly: $sock($sockname).wsmsg
}
alias -l _bugresend {
  sockclose bugrep
  window -c @Progress
  _dialog -am bugresend bugresend
  did -a bugresend 2 $1-
did -a bugresend 5 $gettok($window(@.bug).title,1,32)
  $$$
}
dialog bugresend {
  title "Error sending feedback"
  icon script\pnp.ico
option dbu
size -1 -1 200 96
text "There was an error sending your feedback:", 1, 5 5 200 10
text "", 2, 5 17 200 10
text "You may try to resend, or cancel your feedback.", 3, 5 30 200 10
text "You may need to use your own mail server to send the e-mail- if so, please enter your mail server in the box below.", 4, 5 42 190 17
edit "", 5, 5 61 125 11
button "Retry", 10, 5 78 50 12, OK default
button "Cancel", 11, 145 78 50 12, cancel
}
on *:DIALOG:bugresend:sclick:10:{
  titlebar @.bug $iif(. isin $did(bugresend,5),$gettok($did(bugresend,5),1,32),smtp.pairc.com) $gettok($window(@.bug).titlebar,2,32)
  _bugstart 0
}
on *:DIALOG:bugresend:sclick:11:{
  window -c @.bug
  _unload register
}
