; #= P&P -rs
; ########################################
; Peace & Protection
; Theme / scheme editing and related, also some sound scheme
; ########################################

; Options
; /text [file.ext|on|off|mirc|edit|save file.ext|cfg]
; /nickcol [on|off|edit] (always refreshes)
alias text {
  if ($1 == on) { _cfgw texts 1 | .enable #pp-texts | if ($exists($_cfg(text.dat))) .load -a $_cfg(text.dat) | dispa Text scheme is now $:t(On) ( $+ $_texts.name $+ ) }
  elseif ($1 == off) { _cfgw texts 0 | .disable #pp-texts | dispa Text scheme is now $:t(Off) }
  elseif ($1 == cfg) textopt
  elseif ($1 == mirc) {
    .unload -a " $+ $alias(text.dat) $+ "
    .copy -o script\blanktxs.dat $_cfg(text.dat)
    .load -a $_cfg(text.dat)
    _cfgw texts 1
    .enable #pp-texts
    dispa Default mIRC text scheme loaded!
    if ($dialog(textsch)) did -a textsch 4 $_texts.name
    if ($dialog(textopt)) did -a textopt 6 $_texts.name
  }
  elseif ($1 == save) {
    if ($2 == $null) _error No filename given to save text scheme to.You must give a filename to save the current text scheme to.
    if ($exists($2-)) _fileopt 0 $2-
    .copy -o $_cfg(text.dat) " $+ $2-"
    dispa Current text scheme saved as $:q($2-)
  }
  elseif ($1 == edit) textsch
  elseif ($1) {
    if ($exists($1-) == $false) _error Text scheme file doesn't exist!You must select a P&P text scheme file that exists.
    if (*#=*texts* !iswm $read($1-,n,1)) _error Error in text scheme file! $+ $1- is not a valid P&P text scheme file.
    .unload -a " $+ $alias(text.dat) $+ "
    .copy -o " $+ $1-" $_cfg(text.dat)
    .load -a $_cfg(text.dat)
    _cfgw texts 1
    .enable #pp-texts
    dispa Text scheme file $:q($1-) loaded! ( $+ $_texts.name $+ )
    if ($dialog(textsch)) did -a textsch 4 $_texts.name
    if ($dialog(textopt)) did -a textopt 6 $_texts.name
  }
  elseif ($_cfgi(texts)) dispa Text scheme is $:t(On) ( $+ $_texts.name $+ ) Use $:b(/text cfg) to configure or $:b(/text edit) to edit scheme.
  else dispa Text scheme is $:t(Off) Use $:b(/text cfg) to configure or $:b(/text edit) to edit scheme.
}
alias _texts.name if ($exists($_cfg(text.dat)) == $false) return no text scheme | var %line = $read($_cfg(text.dat),n,1) | if ($gettok(%line,5-,32) != $null) return $ifmatch | return unnamed text scheme
alias nickcol {
  if ($1 == on) _cfgw nickcol 1
  elseif ($1 == off) _cfgw nickcol 0
  elseif ($1 == edit) { ncedit | return }
  if ($_cfgi(nickcol)) {
    .enable #pp-nicklist
    dispa Nicklist coloring is $:t(On)
  }
  else {
    .disable #pp-nicklist
    dispa Nicklist coloring is $:t(Off)
  }
  var %num = 1
  :upd
  if ($chan(%num)) { col.nicklist $ifmatch | inc %num | goto upd }
}

; Make sure nicklist/textscheme options are correct (startup)
alias _upd.texts {
  if (($_cfgi(texts)) && ($exists($_cfg(text.dat)))) {
    .enable #pp-texts
    if ($alias(text.dat) == $null) .load -a $_cfg(text.dat)
  }
  else {
    .disable #pp-texts
    if ($alias(text.dat)) .unload -a " $+ $ifmatch $+ "
  }
  if ($_cfgi(nickcol)) .enable #pp-nicklist
  else .disable #pp-nicklist
}

;
; Modification of display scheme
;
dialog display {
  title "Display Scheme"
  icon script\pnp.ico
  option dbu
  size -1 -1 173 152
  box "Colors:", 201, 2 4 80 70
  text "Base color:", 202, 10 15 50 10, right
  text "Word highlight color:", 203, 10 26 50 10, right
  text "String highlight color:", 204, 10 37 50 10, right
  text "Warning color:", 205, 10 48 50 10, right
  text "Alert background:", 206, 10 59 50 10, right
  icon 3, 63 15 7 7
  icon 4, 63 26 7 7
  icon 5, 63 37 7 7
  icon 6, 63 48 7 7
  icon 7, 63 59 7 7

  box "Brackets:", 207, 90 4 80 70
  text "&Normal:", 208, 95 15 19 10, right
  edit "", 12, 115 13 25 11, autohs
  edit "", 13, 140 13 25 11, autohs
  text "&Whois:", 209, 95 26 19 10, right
  edit "", 10, 115 24 25 11, autohs
  edit "", 11, 140 24 25 11, autohs
  text "&Quotes:", 210, 95 37 19 10, right
  edit "", 16, 115 35 25 11, autohs
  edit "", 17, 140 35 25 11, autohs
  text "&Public:", 211, 95 48 19 10, right
  edit "", 14, 115 46 25 11, autohs
  edit "", 15, 140 46 25 11, autohs
  text "&Bold:", 212, 95 59 19 10, right
  edit "", 8, 115 57 25 11, autohs
  edit "", 9, 140 57 25 11, autohs

  box "Symbols:", 213, 2 79 80 70
  text "&Line bullet:", 214, 7 90 44 10, right
  edit "", 18, 52 88 25 11, autohs
  text "&CTCP symbol:", 215, 7 101 44 10, right
  edit "", 19, 52 99 25 11, autohs
  text "W&allop symbol:", 216, 7 112 44 10, right
  edit "", 20, 52 110 25 11, autohs
  text "&Server notices:", 217, 7 123 44 10, right
  edit "", 21, 52 121 25 11, autohs
  text "B&ulleted list:", 218, 7 134 44 10, right
  edit "", 22, 52 132 25 11, autohs

  text "&Horizontal line:", 219, 95 90 44 10, right
  edit "", 23, 140 88 25 11, autohs

  button "OK", 101, 90 132 25 12, OK default
  button "Cancel", 102, 117 132 25 12, cancel
  button "Help", 103, 145 132 25 12, disable
}
on *:DIALOG:display:init:*:{
  window -hl @.display
  loadbuf @.display $_cfg(display.dat)
  var %num = 3
  :loop
  if (%num < 8) {
    %_color. [ $+ [ %num ] ] = $calc($line(@.display,%num))
    did -g $dname %num script\ $+ $calc($line(@.display,%num)) $+ .bmp
  }
  else did -a $dname %num $line(@.display,%num)
  if (%num < 22) { inc %num | goto loop }
  window -c @.display
  did -a $dname 23 %`horizline
}
on *:DIALOG:display:sclick:101:{
  _cs-fin
  window -hl @.display
  loadbuf @.display $_cfg(display.dat)
  var %num = 3
  :loop
  if (%num < 8) rline @.display %num $_cprep(%_color. [ $+ [ %num ] ] )
  elseif ($did(%num)) rline @.display %num $did(%num)
  else rline @.display %num $cr
  if (%num < 22) { inc %num | goto loop }
  savebuf @.display $_cfg(display.dat)
  window -c @.display
  unset %_color.*
  _upd.markup
  `set horizline $did(23)
}
on *:DIALOG:display:sclick:102:_cs-fin | unset %_color.*
on *:DIALOG:display:sclick:*:if ($did isnum 1-8) _cs-go 15 15 0
alias display _cs-prep | _dialog -am display display

;
; Text options
;
alias textopt _dialog -am textopt textopt
dialog textopt {
  title "Text Options"
  icon script\pnp.ico
  option dbu
  size -1 -1 173 152

  check "&Use P&&P text display: (enable to use any these options)", 1, 2 5 150 8

  text "Current text scheme:", 5, 58 19 125 10
  text "(scheme name)", 6, 58 27 125 10
  button "&Edit text scheme", 7, 7 20 45 12

  box "&Notices:", 8, 4 37 80 40

  radio "Normal", 9, 14 47 50 8, group
  radio "Notices window", 10, 14 56 50 8
  radio "Status window", 11, 14 65 50 8

  box "&Op Notices:", 12, 89 37 80 40

  radio "Normal", 13, 99 47 50 8, group
  radio "Notices window", 14, 99 56 50 8
  radio "Events window", 15, 99 65 50 8

  box "&Services Notices:", 16, 4 82 80 40

  radio "Normal", 17, 14 92 50 8, group
  radio "Notices window", 18, 14 101 50 8
  radio "Status window", 19, 14 110 50 8

  check "&Copy private messages to", 26, 89 100 150 8
  text "active window as well", 31, 98 109 150 8

  button "OK", 101, 7 135 40 12, OK default
  button "Cancel", 102, 66 135 40 12, cancel
  button "He&lp", 103, 126 135 40 12, disable
}
on *:DIALOG:textopt:init:*:{
  if ($_cfgi(texts)) did -c $dname 1 | else _bulkdid -b $dname 5 19
  did -a $dname 6 $_texts.name
  did -c $dname $calc(9 + %`reg.notice)
  did -c $dname $calc(13 + %`op.notice)
  did -c $dname $calc(17 + %`serv.notice)
  if (%`copy.query) did -c $dname 26
}
on *:DIALOG:textopt:sclick:7:_juryrig textsch
on *:DIALOG:textopt:sclick:1:_bulkdid $iif($did(1).state,-e,-b) $dname 5 19
on *:DIALOG:textopt:sclick:101:{
  `set copy.query $did(26).state
  `set reg.notice $iif($did(9).state,0,$iif($did(10).state,1,2))
  `set op.notice $iif($did(13).state,0,$iif($did(14).state,1,2))
  `set serv.notice $iif($did(17).state,0,$iif($did(18).state,1,2))
  if ($did(1).state) { _cfgw texts 1 | .text on } | else { _cfgw texts 0 | .text off }
}

;
; Full theme support, central theme editor (edit/export/import)
;
dialog themes {
  title "P&P Theme Central"
  icon script\pnp.ico
  option dbu
  size -1 -1 172 157
  box "Theme editing:", 101, 2 2 167 67
  button "&Nicklist colors", 1, 7 11 77 11
  button "&Colors and symbols", 2, 7 25 77 11
  button "&Messages", 3, 7 39 77 11
  button "&Text display scheme", 4, 7 53 77 11
  button "&Font settings", 5, 87 11 77 11
  button "&Line separator", 6, 87 25 77 11
  button "&Event sounds", 7, 87 39 77 11
  box "mIRC features:", 102, 2 73 167 61
  text "* To modify mIRC colors, press Alt + K.", 103, 7 83 155 10
  text "* To select toolbar and switchbar bitmaps, right-click on them.", 104, 7 93 155 10
  text "* To select window backgrounds, use the system menu in the upper-left corner of the window. (make sure to also select 'default' to make a background the default, if you want P&&P to store it as part of a theme.)", 105, 7 103 155 27
  button "L&oad theme", 8, 7 141 50 12
  button "&Save theme", 9, 62 141 50 12
  button "Close", 10, 117 141 47 12, cancel
}
on *:DIALOG:themes:sclick:*:if ($did isnum 1-9) _juryrig $gettok(ncedit.display.msgs d.textsch.fontfix.line.soundcfg.theme load.theme save,$did,46)

;
; Sound scheme
;
dialog sounds {
  title "Sounds"
  icon script\pnp.ico
  option dbu
  size -1 -1 150 117
  text "Editing", 101, 2 4 17 10
  combo 1, 20 2 50 65, drop sort
  text "sounds:", 102, 71 4 20 10
  list 2, 2 15 145 55
  edit "", 3, 1 1 1 1, hide autohs
  text "", 4, 5 65 75 7
  text "", 5, 5 72 35 7
  text "", 6, 42 72 105 7
  button "&Select...", 11, 5 82 42 12, default
  button "&Preview", 12, 52 82 42 12
  button "&Clear", 13, 100 82 42 12
  button "&Done", 16, 5 100 42 12, OK
  button "C&opy", 14, 52 100 42 12
  button "P&aste", 15, 100 100 42 12
}
on *:DIALOG:sounds:init:*:{
  window -hl @.sounds
  filter -fw script\scheme.dat @.sounds -*
  var %num = 3 | :loop | if (- * iswm $line(@.sounds,%num)) { did -a $dname 1 $gettok($line(@.sounds,%num),2-,32) | inc %num | goto loop }
  window -c @.sounds
  did -c $dname 1 $_dlgi(sound) 1 | _sndsel
}
on *:DIALOG:sounds:sclick:1:_sndsel
alias -l _sndsel {
  did -r $dname 2,4,5,6 | did -b $dname 12,13,14
  var %file = $_cfg(display.dat),%get = $read(script\scheme.dat,nts,- $did(1)),%num = $readn + 1
  did -o $dname 3 1 $readn
  :loop
  %get = $read(script\scheme.dat,nt,%num)
  if (-* !iswm $gettok(%get,1,32)) {
    if ($read(%file,nt,%num) != .) did -a $dname 2 $gettok(%get,2-,32) ( $+ $nopath($ifmatch) $+ )
    else did -a $dname 2 $gettok(%get,2-,32)
    inc %num | goto loop
  }
  _dlgw sound $did(1).sel
}
on *:DIALOG:sounds:sclick:2:{
  did -a $dname 4 $gettok($did(2,$did(2).sel).text,1,40)
  did -a $dname 5 Current sound:
  var %num = $calc($did(2).sel + $did(3))
  if ($read($_cfg(display.dat),nt,%num) != .) { did -a $dname 6 $ifmatch | did -e $dname 12,13,14 }
  else { did -a $dname 6 (none) | did -b $dname 12,13,14 }
}
on *:DIALOG:sounds:sclick:14:if (($did(2).sel) && ($did(6) != (none))) clipboard $did(6)
on *:DIALOG:sounds:sclick:13:{
  if ($did(2).sel) {
    var %num = $calc($did(2).sel + $did(3))
    write -l [ $+ [ %num ] ] $_cfg(display.dat) .
    did -a $dname 6 (none)
    did -oc $dname 2 $did(2).sel $did(4)
    did -b $dname 12,13,14
    did -t $dname 13 | did -ft $dname 11
  }
}
on *:DIALOG:sounds:sclick:12:{
  var %file = $did(6)
  if ((%file) && (%file != (none))) {
    if ((\ isin %file) || (: isin %file)) .splay " $+ %file $+ "
    elseif ($findfile($mircdir,%file,1)) .splay " $+ $ifmatch $+ "
  }
}
on *:DIALOG:sounds:sclick:11:if ($did(2).sel) _juryrig _sndselc
on *:DIALOG:sounds:dclick:2:_juryrig _sndselc
on *:DIALOG:sounds:sclick:15:if ($did(2).sel) _sndselc $cb(1)
alias _sndselc {
  if ($1) var %new = $1-
  else {
    if ($_dlgi(sounddir)) var %dir = $ifmatch
    else var %dir = $wavedir
    var %new = $sfile(%dir $+ *.wav,Select sound for $did(sounds,4))
  }
  if ($exists(%new)) {
    _dlgw sounddir $nofile(%new)
    var %num = $did(sounds,2).sel + $did(sounds,3)
    write -l [ $+ [ %num ] ] $_cfg(display.dat) $_rel.fn(%new)
    did -a sounds 6 %new
    did -oc sounds 2 $did(sounds,2).sel $did(sounds,4) ( $+ $nopath(%new) $+ )
    did -e sounds 12,13,14
  }
  dialog -v sounds
}
alias soundcfg _dialog -am sounds sounds

;
; Messages
;
;;; $read'ing open for optimization
alias msgs {
  if ($window(@Messages)) clear @Messages
  else _window 2 -l $+ $iif($1,d) -t35 @Messages -1 -1 -1 -1 @Messages
  aline @Messages $:w() Double-click to edit a message
  aline @Messages $:w() Select one and right-click for defaults
  aline @Messages $:w() Select one and right-click to use random lines
  aline @Messages  
  var %group,%file = $_cfg(display.dat),%get = $read(script\scheme.dat,s,-- message),%num = $readn + 1 | :loop
  %group = $read(script\scheme.dat,nt,%num)
  if (%group == -) aline @Messages  
  elseif ($gettok(%group,1,32) == -) aline @Messages $:w() $:b($gettok(%group,2-,32))
  elseif ($gettok(%group,1,32) == --) { window -b @Messages | return }
  else {
    %get = $read(%file,nt,%num)
    if (!Random:* iswm %get) aline @Messages   $:s() $_p2s($gettok(%group,2,32)) -	 $+ $:b($gettok(%get,2-,58)) (random line)
    else aline @Messages   $:s() $_p2s($gettok(%group,2,32)) -	 $+ %get
  }
  inc %num | goto loop
}
menu @Messages {
  dclick:if ( !isin $gettok($line(@Messages,$1),3,32)) return | _msgdo $1
  $_msgprep:_msgdo $sline(@Messages,1).ln
  %.msg2:{
    var %new = $$sfile(*.txt,Select file for random messages)
    %new = $_rel.fn(%new)
    var %line = $read(script\scheme.dat,s,-- message),%base = $readn - 4
    %line = $sline(@Messages,1).ln
    rline @Messages %line $gettok($line(@Messages,%line),1,9) 	 $+  $+ %new $+  (random line)
    write -l [ $+ [ $calc(%line + %base) ] ] $_cfg(display.dat) !Random: $+ %new
    window -b @Messages
  }
  -
  %.msg8:_msgdef $sline(@Messages,1).ln
  -
  %.msg3:_msgdef $sline(@Messages,1).ln 3
  %.msg4:_msgdef $sline(@Messages,1).ln 4
  %.msg5:_msgdef $sline(@Messages,1).ln 5
  %.msg6:_msgdef $sline(@Messages,1).ln 6
  %.msg7:_msgdef $sline(@Messages,1).ln 7
}
alias -l _msgdo {
  var %old = $gettok($line(@Messages,$1),2-,9)
  if ((* (random line) iswm %old) || (%old ==  )) var %old
  var %ques = $gettok($gettok($line(@Messages,$1),1,45),4-,32) $+ ?,%new = $_entry(0,$_s2p(%old),%ques),%base = $read(script\scheme.dat,s,-- message)
  %base = $readn - 4
  rline @Messages $1 $gettok($line(@Messages,$1),1,9) 	 $+ %new
  write -l [ $+ [ $calc($1 + %base) ] ] $_cfg(display.dat) %new
  window -b @Messages
}
alias -l _msgprep {
  unset %.msg?
  if ( !isin $gettok($sline(@Messages,1),3,32)) return
  set -u %.msg2 Random...
  var %base = $read(script\scheme.dat,s,-- message) | %base = $readn - 4
  var %data = $read(script\scheme.dat,tn,$calc($sline(@Messages,1).ln + %base))
  if (%data) { var %num = 3 | :loop | if ($gettok(%data,%num,32)) { if ($chr(124) isin $ifmatch) set -u %.msg [ $+ [ %num ] ] $replace($_p2s($gettok($gettok(%data,%num,32),2,124)),&,&&) | else set -u %.msg [ $+ [ %num ] ] $replace($_p2s($gettok(%data,%num,32)),&,&&) | inc %num | goto loop } }
  if (* iswm $gettok(%data,2,32)) set -u %.msg8 (none or blank)
  return Modify...
}
alias -l _msgdef {
  var %base = $read(script\scheme.dat,s,-- message) | %base = $readn - 4
  if ($2) {
    var %new = $read(script\scheme.dat,tn,$calc($1 + %base))
    %new = $_p2s($gettok($gettok(%new,$2,32),1,124))
  }
  else var %new =  
  write -l [ $+ [ $calc($1 + %base) ] ] $_cfg(display.dat) %new
  if (!Random:* iswm %new) rline @Messages $1 $gettok($line(@Messages,$1),1,9) 	 $+  $+ $gettok(%new,2-,58) $+  (random line) 
  else rline @Messages $1 $gettok($line(@Messages,$1),1,9) 	 $+ %new
  window -b @Messages
}

;
; Text display scheme dialog
;

dialog textsch {
  title "Text Display Scheme"
  icon script\pnp.ico
  option dbu
  size -1 -1 173 100
  box "Text scheme:", 2, 4 5 165 37
  text "Current:", 3, 8 14 20 10
  text "(scheme name)", 4, 29 14 125 10
  button "&Load scheme", 5, 7 25 45 12
  button "&Save scheme", 6, 61 25 45 12
  button "&Default mIRC text", 7, 114 25 50 12
  text "* To edit the text scheme (for advanced users only!) go into mIRC aliases and edit the file text.dat. You can then save your new scheme from here. (you must resave it if you make changes later that you want saved.)", 8, 8 47 150 27
  button "Done", 101, 37 82 45 12, OK default
  button "&Help", 103, 89 82 45 12, disable
}
on *:DIALOG:textsch:init:*:did -a $dname 4 $_texts.name
on *:DIALOG:textsch:sclick:5:_juryrig _txtload
alias _txtload var %file = $sfile($mircdirschemes\*.*,Select a text scheme) | dialog -v textsch | if (%file) text %file
on *:DIALOG:textsch:sclick:6:_juryrig _txtsave
alias _txtsave var %file = $sfile($mircdirschemes\ $+ $remove($_texts.name,$chr(32)) $+ .txs,Save text scheme,Save) | dialog -v textsch | if (%file) text save %file
on *:DIALOG:textsch:sclick:7:text mirc
alias textsch _dialog -am textsch textsch

;
; Some sound schemes
;

on *:KICK:#:_ssplay $iif($knick == $me,youkick,anykick) | if ($knick == $me) { unset %-=*. $+ $chan | flash [kicked from $chan $+ ]] }
on *:OP:#:if ($opnick == $me) _ssplay youop
on *:VOICE:#:if ($vnick == $me) _ssplay youop
on *:SERVEROP:#:if ($opnick == $me) _ssplay youop
on *:DEOP:#:if ($opnick == $me) _ssplay youdeop
on *:DEVOICE:#:if ($vnick == $me) _ssplay youdeop
on *:DISCONNECT:_ssplay $iif(%-quitrequest,youquit,disconnect)
on *:CONNECT:_ssplay connect
on *:FILESENT:*:_ssplay senddone
on *:FILERCVD:*:_ssplay getdone
on *:SENDFAIL:*:_ssplay fileerror
on *:GETFAIL:*:_ssplay fileerror

;
; Events routing
;
alias route set %.chan $1 | _dialog -am evroute evroute
dialog evroute {
  title "Event routing"
  icon script\pnp.ico
  option dbu
  size -1 -1 173 111

  text "Event routing for:", 1, 2 5 50 8
  combo 9, 47 3 115 50, drop edit sort

  text "&Joins:", 2, 4 19 25 10
  text "&Parts:", 3, 4 29 25 10
  text "&Quits:", 4, 4 39 25 10
  text "&Kicks:", 5, 4 49 25 10
  text "&Modes:", 6, 4 59 25 10
  text "&Topics:", 7, 4 69 25 10
  text "&Nicks:", 8, 4 79 25 10

  radio "mIRC setting", 11, 30 19 40 8, group
  radio "Events window", 12, 72 19 50 8
  radio "Don't show", 13, 122 19 50 8

  radio "mIRC setting", 21, 30 29 40 8, group
  radio "Events window", 22, 72 29 50 8
  radio "Don't show", 23, 122 29 50 8

  radio "mIRC setting", 31, 30 39 40 8, group
  radio "Events window", 32, 72 39 50 8
  radio "Don't show", 33, 122 39 50 8

  radio "mIRC setting", 41, 30 49 40 8, group
  radio "Events window", 42, 72 49 50 8
  radio "Don't show", 43, 122 49 50 8

  radio "mIRC setting", 51, 30 59 40 8, group
  radio "Events window", 52, 72 59 50 8
  radio "Don't show", 53, 122 59 50 8

  radio "mIRC setting", 61, 30 69 40 8, group
  radio "Events window", 62, 72 69 50 8
  radio "Don't show", 63, 122 69 50 8

  radio "mIRC setting", 71, 30 79 40 8, group
  radio "Events window", 72, 72 79 50 8
  radio "Don't show", 73, 122 79 50 8

  button "&Close", 101, 7 94 40 12, cancel default
  button "&Reset", 102, 66 94 40 12
  button "&Help", 103, 126 94 40 12, disable
}
on *:DIALOG:evroute:*:9:_evswitchto
alias -l _evconv if ($_ischan($1-)) return . $+ $1 | return
alias -l _evswitchto {
  tokenize 32 $_evconv($did(9,$did(9).sel))
  var %num = 1
  :loop2
  var %value = %`event. [ $+ [ $remove($did($calc(%num + 1)),s,&,:) ] $+ [ $1 ] ]
  if (%value == $null) %value = %`event. [ $+ [ $remove($did($calc(%num + 1)),s,&,:) ] ]
  if (%value == hide) %value = 3 | else %value = $iif(%value,2,1)
  did -u $dname %num $+ 3, $+ %num $+ 2, $+ %num $+ 1
  did -c $dname %num $+ %value
  if (%num < 7) { inc %num | goto loop2 }
}
on *:DIALOG:evroute:init:*:{
  var %num = 1
  :loop1
  if ($chan(%num)) {
    did -a $dname 9 $ifmatch
    inc %num
    goto loop1
  }
  window -nlh @.evroute
  filter -fw $_cfg(cfgvar.dat) @.evroute event.*
  %num = $line(@.evroute,0)
  :loop2
  if (%num) {
    var %chan = $gettok($gettok($line(@.evroute,%num),3-,46),1,32)
    if (%chan) {
      _ddadd $dname 9 $ifmatch
      if (%chan == $active) %.chan = $active
    }
    dec %num
    goto loop2
  }
  window -c @.evroute
  did -ac $dname 9 (all channels)
  if ($_ischan(%.chan)) {
    if ($_finddid($dname,9,%.chan)) did -c $dname 9 $ifmatch
    else did -ac $dname 9 %.chan
  }
  unset %.chan
  _evswitchto
}
on *:DIALOG:evroute:sclick:102:{
  var %where = $_evconv($did(9)),%num = 1
  if (%where == $null) {
    :loop1
    `set event. $+ $remove($did($calc(%num + 1)),s,&,:) $false
    did -u $dname %num $+ 3
    did -u $dname %num $+ 2
    did -c $dname %num $+ 1
    if (%num < 7) { inc %num | goto loop1 }
  }
  else {
    :loop2
    var %name = $remove($did($calc(%num + 1)),s,&,:),%value = %`event. [ $+ [ %name ] ]
    `set event. $+ %name $+ %where
    if (%value == hide) %value = 3 | else %value = $iif(%value,2,1)
    did -u $dname %num $+ 3, $+ %num $+ 2, $+ %num $+ 1
    did -c $dname %num $+ %value
    if (%num < 7) { inc %num | goto loop2 }
  }
}
on *:DIALOG:evroute:sclick:*:{
  if ($did isnum 11-73) {
    var %where = $_evconv($did(9)),%value = $gettok($!false $true hide,$calc($did % 10),32),%name = $remove($did($int($calc($did / 10 + 1))),s,&,:)
    if ((%where != $null) && (%`event. [ $+ [ %name ] ] == %value)) var %value
    `set event. $+ %name $+ %where %value
  }
}
